#! /usr/bin/env python
# Copyright (c) 2017 Cisco and/or its affiliates.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
import os
import subprocess
import re
import sys
import pprint

ansiRed = "\x1b[31m";
ansiGreen = "\x1b[32m";
ansiYellow = "\x1b[33m";
ansiBlue = "\x1b[34m";
ansiMagenta = "\x1b[35m";
ansiCyan = "\x1b[36m";
ansiReset = "\x1b[0m";

def colorize(color, chars):

    result = chars
    if color == "red":
        result = ansiRed + chars + ansiReset
    elif color == "green":
        result = ansiGreen + chars + ansiReset
    elif color == "yellow":
        result = ansiYellow + chars + ansiReset
    elif color == "blue":
        result = ansiBlue + chars + ansiReset
    elif color == "magenta":
        result = ansiMagenta + chars + ansiReset
    elif color == "cyan":
        result = ansiCyan + chars + ansiReset
    else:
        print >> sys.stderr, "Bad color name:", color

    return result


def printColorized(color, string):
    print colorize(color, string)
    return


class ANSITerm:
  def __init__(self):
    return

  def printColorized(self, color, string):
    print colorize(color, string)
