#! /usr/bin/env python
# Copyright (c) 2017 Cisco and/or its affiliates.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at:
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
import os
import subprocess
import re
import sys
import pprint
import FileUtil
import Language_C


def removeTestSourceFiles(gcovSummary):
    deleteThese = filter(lambda entry: Language_C.Module(entry).isTestSourceName(), gcovSummary)

    for entry in deleteThese:
        del gcovSummary[entry]

    return gcovSummary


def averageCoverage(summary):
    score = 0.0

    if len(summary) > 0:
        sum = reduce(lambda x, y: x + y, map(lambda entry: summary[entry]["coverage"], summary))
        score = sum / float(len(summary))

    return score
